require 'asbru/components/savage'

module Asbru
  module Links
    module Helper
      def asbru_link(text,
          url,
          method: nil,
          link: true,
          remote: false,
          confirm: nil,
          **options)
        options[:text] = text
        options[:action] = url
        options[:link] = link

        options[:customData] = {}
        options[:customData][:'data-method'] = method if method.present?
        options[:customData][:'data-confirm'] = confirm if confirm.present?
        options[:customData][:'data-remote'] = remote if remote.present?
        options[:customData].merge!(options[:custom_data]) if options[:custom_data]

        Asbru::Components::Savage.send "#{Asbru.config.component_prefix}_button",
          **options
      end

      def asbru_link_to(text, url, **options)
        asbru_link text, url, **options
      end
    end
  end
end
